//
// C++ Implementation: k9execcopy
//
// Description: 
//
//
// Author:  <>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "k9execcopy.h"
#include "k9dialogs.h"
#include "k9dvdsize.h"
#include "k9dvdbackup.h"
#include "k9config.h"
#include "k9dvdauthor.h"
#include "k9tools.h"
#include <QDir>
#include <KMessageBox>
#include "k9mp4enc.h"
#include "k9dvdtitle.h"
#include "k9titleencopt.h"
#include "k9burndvd.h"
void k9ExecCopy::copyDVD() {
    k9Config config;

    QString c,filename;
    if (!m_dvd->getopened()) {
        k9Dialogs::error(  i18n("DVD is not opened"), i18n("DVD Copy"));
        return;
    }

    k9DVDSize *dvdsize=new k9DVDSize();
    dvdsize->setMaxSizeDyn(config.getPrefSize());
    delete dvdsize;

    QString outputDir=config.getPrefOutput() ;
    bool burn=false;

    if (m_output==oISO) {
        filename=m_path;
    } else{
	if (m_output==oFolder) 
           outputDir= m_path;
	QDir dir(m_path);
	if (!dir.exists()) {
		dir.mkpath(m_path);
	}
    }

    long fs=k9Tools::getFreeSpace(outputDir);
    if ((fs <  config.getPrefSize()) && (fs !=-1)) {
        if (k9Dialogs::warningContinueCancel ( i18n("Insufficient disk space on %1\n%2 mb expected.",outputDir,config.getPrefSize()),i18n("DVD Copy"))==KMessageBox::Cancel)
            return;
    }

//    stopPreview();
    if (!config.getUseDvdAuthor() || m_copyMenus) {

        k9DVDBackup *backup=new k9DVDBackup(m_dvd);

        backup->setOutput(outputDir);
        backup->setDevice(m_dvd->getDevice());
        backup->setWithMenus( m_copyMenus);
        backup->execute();
        burn=backup->getErrMsg()=="";
        delete backup;
    } else {
        k9DVDAuthor *b=new k9DVDAuthor(m_dvd);
        b->setworkDir(outputDir);
        b->author();
        if (!b->getError())
            burn=true;

        delete b;
    }

    if (burn && m_output!=oFolder) {
        k9BurnDVD b;

        b.setworkDir(outputDir +"/"+ m_dvd->getDVDTitle());
        b.setUseK3b(config.getPrefK3b());
        b.setAutoBurn(config.getPrefAutoBurn());
        b.setvolId(m_dvd->getDVDTitle());
        b.setSpeed( i18n("default"));
        if (m_output==oDVD) {
            b.setburnDevice(m_path);
            m_dvd->close();
            if (m_dvd->getDevice()==m_path)
                b.setAutoBurn(false);
        } else
            b.makeIso(m_path);
        b.burn();
    } else if (burn && m_output==oFolder)
       k9Dialogs::information( i18n("Selected titles have been successfully extracted"), i18n("DVD Copy") );


}


void k9ExecCopy::CreateMP4() {
    k9Config config;

    if (!m_dvd->getopened()) {
        k9Dialogs::error(  i18n("DVD is not opened"), i18n("MPEG-4 Encoding"));
        return;
    }
    QString filename=m_path;
    int cpt=0;
    bool bStop=false;

    QDir dir(config.getPrefOutput());
    if (!dir.exists()) {
        dir.mkpath(config.getPrefOutput());
    }

    for (int i=0; i < m_dvd->gettitleCount();i++) {
        k9DVDTitle *t=m_dvd->gettitle(i);
  
        if (t->isSelected() && t->getIndexed() ) {
            QString name;
            if (filename=="")
                filename=k9Dialogs::getSaveFileName (QDir::homePath(),"*.avi|Audio Video Interleave (*.avi)\n*.mpg|MPEG-1 and MPEG-2 systems (*.mpg)\n*.mp4|MPEG-4 format (*.mp4)\n*.asf|Advanced Streaming Format (*.asf)\n*.swf|Adobe Flash (*.swf)\n*.flv|Adobe Flash video files (*.flv)\n*.rm|RealVideo (*.rm)\n*.mov|QuickTime (*.mov)", 0,i18n("Save file to disk"));
            if (filename=="") {
                bStop=true;
                break;
            }

            k9MP4Enc *mp4=new k9MP4Enc();
            if (cpt >0) {
                QString ext=filename.section(".",-1);
                if (ext!="")
                    ext="."+ext;
                QString path=filename.left(filename.length()-ext.length());
                path=path+QString::number(cpt)+ext;
                mp4->setFilename(path);
            } else
                mp4->setFilename(filename);

            cpt++;
            k9TitleEncOpt * opt=t->getEncOpt();
            mp4->setDevice(m_dvd->getDevice());
            mp4->setAudioBitrate(opt->getAudioBr());
            mp4->setVideoBitrate(opt->getVideoBr());
            mp4->setCodec( opt->getCodec());
            mp4->setAudioCodec(opt->getAudioCodec());
            mp4->setSize(QString::number(opt->getMaxSize()));
            mp4->setAudioGain(QString::number(opt->getAudioGain()));
            mp4->setNumberCD(QString::number(opt->getNumParts()));
            mp4->setWidth(opt->getWidth() );
            mp4->setHeight(opt->getHeight());
            mp4->set2Passes( opt->get2Passes());
            mp4->setUseCache(opt->getUseCache());
            mp4->execute(t);
            bStop=mp4->isCanceled();
            delete mp4;
            if (bStop)
                break;
        }
    }
    if (!bStop)
        k9Dialogs::information( i18n("Selected titles have been successfully encoded"), i18n("Encoding") );

}


void k9ExecCopy::extractMPEG2() {
   k9Config config;
 
   if (!m_dvd->getopened()) {
        k9Dialogs::error(  i18n("DVD is not opened"), i18n("MPEG-4 Encoding"));
        return;
    }
    QString filename=m_path;
    int cpt=0;
    bool bStop=false;

    QDir dir(config.getPrefOutput());
    if (!dir.exists()) {
        dir.mkpath(config.getPrefOutput());
    }

    for (int i=0; i < m_dvd->gettitleCount();i++) {
        k9DVDTitle *t=m_dvd->gettitle(i);

        if (t->isSelected() && t->getIndexed() ) {
            QString name;
            if (filename=="")
                filename=k9Dialogs::getSaveFileName (QDir::homePath(),"*.mpg|MPEG-1 and MPEG-2 systems (*.mpg)", 0,i18n("Save file to disk"));
            if (filename=="") {
                bStop=true;
                break;
            }

            k9MP4Enc *mp4=new k9MP4Enc();
            mp4->setMpeg2(true);
            if (cpt >0) {
                QString ext=filename.section(".",-1);
                if (ext!="")
                    ext="."+ext;
                QString path=filename.left(filename.length()-ext.length());
                path=path+QString::number(cpt)+ext;
                mp4->setFilename(path);
            } else
                mp4->setFilename(filename);

            cpt++;
            mp4->setDevice(m_dvd->getDevice());
	    mp4->setUseCache(false);
            mp4->execute(t);
            bStop=mp4->isCanceled();
            delete mp4;
            if (bStop)
                break;
        }
    }
    if (!bStop)
        k9Dialogs::information( i18n("Selected titles have been successfully extracted"), i18n("Encoding") );


}


